//
//  CPPApplication.h
//  CPPAppKitTest
//
//  Created by Dan Libisch on 2/25/12.
//  Copyright 2012 Dan Libisch. All rights reserved.
//

#ifndef _CPP_APPLICATION_H_
#define _CPP_APPLICATION_H_

#include "CPPResponder.h"
//#include "CPPMainWindow.h"


class CPPApplication : public CPPResponder
{
private:
	CPPMainWindow	*mainWindow;
	
	bool			isRunning;
	bool			wndCloseApp;
	
public:
	// c++ functions
	CPPApplication();
	virtual~CPPApplication();
	
	virtual bool Message(int msg, void *data=NULL);
	
	bool ApplicationShouldTerminate(void);
	bool ApplicationWillTerminate(void);
	
	void InitMainWindow(int w, int h);
	CPPMainWindow* GetMainWindow(void);
	void DeleteMainWindow(void);
	
	void SetMainAppColors(void);
	
	void SetIsRunning(bool flag);
	void SetMainWindowClosesApplication(bool flag);
	bool MainWindowClosesApplication(void);

	void RunLoop(void);
	int Execute(void);
	
	// application events
	virtual void LeftMouseDown(CGEventRef cgEvent);// for debugging

	virtual void KeyDown(CGEventRef cgEvent);
	virtual void KeyUp(CGEventRef cgEvent);
	
	virtual void FlagsChanged(CGEventRef cgEvent);
	
	
	// objective-c call functions
	void InitSharedApplication(void);
	id GetApplicationName(void);
	void InitMainMenu(void);
	
	void SetDelegate(id del);
	void FinishLaunching(void);
	
	CGEventRef PollNextEvent(void);
	void ForwardEventToNSApplication(void);
	
	void TerminateApplication(id sender);
	
};


#endif