/*
 *  CPPControl.h
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/22/12.
 *  Copyright 2012 Libisch Graphic Design. All rights reserved.
 *
 */

#ifndef _CPP_CONTROL_H_
#define _CPP_CONTROL_H_


#include "CPPTextView.h"


// control label class
class CPPControlLabel : public CPPTextView
{
protected:
	bool		centered;
	
public:
	CPPControlLabel();
	virtual ~CPPControlLabel();
	
	id InitLabel(int font, CGFloat size, const char *str, int align);
	
	//void SetColors(CPPColor nClr, CPPColor hClr, CPPColor dClr);
	void SetNormalColor(void);
	void SetHilightColor(void);
	
	void CenterLabel(void);
	void SetIsCentered(bool flag);
	bool IsCentered(void);
};



//base class for GUI controls
class CPPControl : public CPPView
{
protected:
	bool				active;
	
public:
	CPPControl();
	virtual ~CPPControl();
	
	virtual void Draw(void);
	virtual bool Message(int msg, void *data=NULL);
	
	void SetIsActive(bool flag);
	bool IsActive(void);
	
	void AddControlLabel(CPPControlLabel *label);
	
};


#endif