/*
 *  CPPMainWindow.h
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/1/12.
 *  Copyright 2012 Dan Libisch. All rights reserved.
 *
 */

#ifndef _CPP_MAIN_WINDOW_H_
#define _CPP_MAIN_WINDOW_H_


#include "CPPWindow.h"
#include "CPPOpenGL3DViewPort.h"
#include "CPPMenu.h"


class CPPMainWindow : public CPPWindow
{
private:
	CPPOpenGL3DViewPort		*glView;
	CPPMenuBar				*mBar;
	
public:	
	// c++ functions
	CPPMainWindow();
	virtual ~CPPMainWindow();
	
	virtual bool WindowShouldClose(void);
	
	CPPMenuBar* InitWindowMenuBar(CGRect wndRect, CGFloat ht);
	CPPMenuBar* GetMenuBar(void);
	
	bool CreateOpenGL3DViewPort(CGRect cRect);
	CPPOpenGL3DViewPort* GetOpenGLView(void);
	void DeleteOpenGLView(void);
	
	// window events
	virtual void KeyDown(CGEventRef cgEvent);
	virtual void KeyUp(CGEventRef cgEvent);
	
	virtual void FlagsChanged(CGEventRef cgEvent);
	
};


#endif