/*
 *  CPPOpenGL3DViewPort.h
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/2/12.
 *  Copyright 2012 Dan Libisch. All rights reserved.
 *
 */

#ifndef _CPP_OPENGL_3D_VIEW_PORT_H_
#define _CPP_OPENGL_3D_VIEW_PORT_H_


#include "CPPOpenGLView.h"
#include "Grid.h"


class CPPOpenGL3DViewPort : public CPPOpenGLView
{
private:
	CGColorRef bgrTColor;
	CGColorRef bgrBColor;
	
	Grid	*grid;
	
	// view navigation
	CGPoint		mDragStart;
	bool		navigating;
	int			mxLast, myLast, mwLast;

	GLdouble	fieldOfView;
	GLdouble	nearClip;
	GLdouble	farClip;
	
	GLfloat	viewRotateX;
	GLfloat	viewRotateY;
	GLfloat	viewPositionX;
	GLfloat	viewPositionY;
	GLfloat	viewPositionZ;
	
public:
	// c++ functions
	CPPOpenGL3DViewPort();
	virtual ~CPPOpenGL3DViewPort();

	virtual void Draw(void);
	virtual bool Message(int msg, void *data=NULL);
	
	// OpenGL
	virtual void InitOpenGL(void);
	
	void DrawViewPortBackground(void);
	void SetBackgroundColors(CGColorRef top, CGColorRef bottom);

	void SetViewPortRotation(GLfloat x, GLfloat y);
	void SetViewPortPosition(GLfloat x, GLfloat y, GLfloat z);
	
	void SetFieldOfView(GLdouble fov);
	void SetNearClip(GLdouble nc);
	void SetFarClip(GLdouble fc);

	// view events
	virtual void LeftMouseDown(CGEventRef cgEvent);
	virtual void RightMouseDown(CGEventRef cgEvent);
	virtual void OtherMouseDown(CGEventRef cgEvent);
	
	virtual void LeftMouseUp(CGEventRef cgEvent);
	virtual void RightMouseUp(CGEventRef cgEvent);
	virtual void OtherMouseUp(CGEventRef cgEvent);
	
	virtual void MouseMoved(CGEventRef cgEvent);
	virtual void ScrollWheel(CGEventRef cgEvent);
	
	virtual void LeftMouseDragged(CGEventRef cgEvent);
	virtual void RightMouseDragged(CGEventRef cgEvent);
	virtual void OtherMouseDragged(CGEventRef cgEvent);
	
	virtual void KeyDown(CGEventRef cgEvent);
	virtual void KeyUp(CGEventRef cgEvent);
	
	virtual void FlagsChanged(CGEventRef cgEvent);
	
};



#endif