/*
 *  CPPOpenGLView.h
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/2/12.
 *  Copyright 2012 Dan Libisch. All rights reserved.
 *
 */

#ifndef _CPP_OPENGL_VIEW_H_
#define _CPP_OPENGL_VIEW_H_


#include "CPPView.h"


// Base class for OpenGL view
class CPPOpenGLView : public CPPView
{
public:
	// c++ functions
	CPPOpenGLView();
	virtual~CPPOpenGLView();

	virtual void Draw(void);
	virtual bool Message(int msg, void *data=NULL);
	
	// OpenGL
	virtual void InitOpenGL(void) {}

	void SetPerspectiveProjection(CGRect &cntRect, GLdouble fov, GLdouble nclp, GLdouble fclp);
	void SetOrthoProjection(CGRect &cntRect);
	
	// objective-c call functions
	id InitWithFrame(CGRect cRect, bool view3D=false);
	
	void SetCppNsOpenGLViewPointer(CPPOpenGLView *glvw);
	void MakeCurrentContext(void);
	void Set3DViewPixelFormat(void);
	
	void FlushBuffer(void);
	
};



#endif