/*
 *  CPPPanel.h
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/17/12.
 *  Copyright 2012 Libisch Graphic Design. All rights reserved.
 *
 */

#ifndef _CPP_PANEL_H_
#define _CPP_PANEL_H_


#include "CPPWindow.h"


// Base class for panel
class CPPPanel : public CPPWindow
{
public:
	// c++ functions
	CPPPanel();
	virtual ~CPPPanel();
	
	virtual void Draw(void);
	virtual bool Message(int msg, void *data=NULL);
	
	void OpenPanel(void);
	
	
	// objective-c call functions
	virtual void InitWithContentRect(CGRect cRect, unsigned int style);
	
	void ClosePanel(void);
	
	void SetCppNsPanelPointer(CPPPanel *pnl);
	
	BOOL IsFloatingPanel(void);
	void SetFloatingPanel(BOOL flag);
	
	BOOL BecomesKeyOnlyIfNeeded(void);
	void SetBecomesKeyOnlyIfNeeded(BOOL flag);
	
	BOOL WorksWhenModal(void);
	void SetWorksWhenModal(BOOL flag);

};


#endif