/*
 *  CPPResponder.h
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/4/12.
 *  Copyright 2012 Dan Libisch. All rights reserved.
 *
 */

#ifndef _CPP_RESPONDER_H_
#define _CPP_RESPONDER_H_

#include "CPPObject.h"


// base class for even handling objects
class CPPResponder : public CPPObject
{
protected:
	bool		respond;
	
	int			mxDelta;
	int			myDelta;
	int			mwDelta;
	int			mClick;		
	
public:
	
	CPPResponder();
	virtual ~CPPResponder();
	
	virtual bool Message(int msg, void *data=NULL);
	
	void SetRespondsToEvents(bool flag);
	bool IsResponder(void);
	
	// event functions
	virtual bool DispatchCGEvents(CGEventRef cgEvent);
	virtual bool HandleEvents(CGEventRef cgEvent);
	
	virtual void LeftMouseDown(CGEventRef cgEvent);
	virtual void RightMouseDown(CGEventRef cgEvent);
	virtual void OtherMouseDown(CGEventRef cgEvent);
	
	virtual void LeftMouseUp(CGEventRef cgEvent);
	virtual void RightMouseUp(CGEventRef cgEvent);
	virtual void OtherMouseUp(CGEventRef cgEvent);
	
	virtual void MouseMoved(CGEventRef cgEvent);
	virtual void ScrollWheel(CGEventRef cgEvent);
	
	virtual void LeftMouseDragged(CGEventRef cgEvent);
	virtual void RightMouseDragged(CGEventRef cgEvent);
	virtual void OtherMouseDragged(CGEventRef cgEvent);
	
	virtual void KeyDown(CGEventRef cgEvent);
	virtual void KeyUp(CGEventRef cgEvent);
	
	virtual void FlagsChanged(CGEventRef cgEvent);
	
};



#endif