/*
 *  CPPTextView.h
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/17/12.
 *  Copyright 2012 Libisch Graphic Design. All rights reserved.
 *
 */

#ifndef _CPP_TEXT_VIEW_H_
#define _CPP_TEXT_VIEW_H_


#include "CPPView.h"


// Base class for text view
class CPPTextView : public CPPView
{	
public:
	// c++ functions
	CPPTextView();
	virtual ~CPPTextView();
	
	virtual void Draw(void);
	virtual bool Message(int msg, void *data=NULL);
	
	// objective-c call functions
	virtual id InitWithFrame(CGRect cRect);
	
	void SetCppNsTextViewPointer(CPPTextView *tvw);
	
	void SetBackgroundColor(CGFloat r, CGFloat g, CGFloat b, CGFloat a);
	void SetDrawsBackground(BOOL flag);
	
	void SetTextColor(CPPColor color);
	void SetTextColor(CGFloat r, CGFloat g, CGFloat b, CGFloat a);
	void SetTextContainerInset(CGFloat w, CGFloat h);
	void SetFont(int font, CGFloat size);
	void SetAlignment(int align);
	void LowerBaseline(int pts);
	
	void SetString(const char *str);
	const char* GetString(void);
	
	void MakeStaticText(void);
	
	void SetAllowsUndo(BOOL flag);
	void SetEditable(BOOL flag);
	void SetSelectable(BOOL flag);
	void SetFieldEditor(BOOL flag);
	void SetRichText(BOOL flag);
	void SetImportsGraphics(BOOL flag);
	
	CGFloat GetPointSize(void);
	
};

#endif