/*
 *  CPPView.h
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/17/12.
 *  Copyright 2012 Libisch Graphic Design. All rights reserved.
 *
 */

#ifndef _CPP_VIEW_H_
#define _CPP_VIEW_H_


#include "CPPResponder.h"


// Base class for view
class CPPView : public CPPResponder
{
protected:
	CPPWindow			*window;
	CGRect				vwRect;
	ViewMargins			margins;
	
	//id				wndPtr; // pointer to the window
	
public:
	// c++ functions
	CPPView();
	virtual ~CPPView();
	
	virtual void Draw(void);
	virtual bool Message(int msg, void *data=NULL);
	
	void SetCPPWindow(CPPWindow *wnd);
	CPPWindow* GetCPPWindow(void);
	
	void SetViewRect(CGRect cRect);
	CGRect GetViewRect(void);
	
	void ResizeViewRect(CGRect wndRect);
	
	void SetViewOrigin(CGPoint origin);
	CGPoint GetViewOrigin(void);
	
	void SetViewSize(CGSize size);
	CGSize GetViewSize(void);
	
	void SetViewMargins(int l, int t, int r, int b);
	void SetViewLeftMargin(int l);
	void SetViewTopMargin(int t);
	void SetViewRightMargin(int r);
	void SetViewBottomMargin(int b);
	ViewMargins GetViewMargins(void);
	
	// objective-c call functions
	virtual id InitWithFrame(CGRect cRect);
	
	void SetCppNsViewPointer(CPPView *vw);
	void SetAcceptsMouseMovedEvents(BOOL mm);
	
	bool MouseInViewRect(CGPoint mPos);
	
	void AddSubview(CPPView *view);
	
	void SetFrame(CGRect rect);
	CGRect GetFrame(void);
	
	void SetFrameSize(CGSize size);
	CGSize GetFrameSize(void);
	
	void SetFrameOrigin(CGPoint origin);
	CGPoint GetFrameOrigin(void);

	void SetNeedsDisplay(BOOL flag);
	
	id GetNSWindow(void);

	CGRect GetSuperviewFrame(void);
	CGRect GetViewContentFrame(void);
	
	CGRect GetWindowFrame(void);
	CGRect GetWindowContentFrame(void);
	CGRect GetWindowContentRect(void);
	
};


#endif