/*
 *  CPPWindow.h
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/1/12.
 *  Copyright 2012 Dan Libisch. All rights reserved.
 *
 */

#ifndef _CPP_WINDOW_H_
#define _CPP_WINDOW_H_


#include "CPPResponder.h"
#include "CPPView.h"


// Base class for window
class CPPWindow : public CPPResponder
{
protected:
	CGRect		wndFrame;
	CGRect		cntFrame;
	
	CPPView		*cntView;
	
	bool		wndIsOpen;
	
public:	
	// c++ functions
	CPPWindow();
	virtual ~CPPWindow();
	
	virtual void Draw(void);
	virtual bool Message(int msg, void *data=NULL);
	
	virtual bool WindowShouldClose(void);
	bool WindowWillClose(void);
	
	bool WindowDidResize(void);
	bool WindowDidMove(void);
	
	void SetWindowIsOpen(bool flag);
	bool WindowIsOpen(void);
	
	bool CreateContentView(CGRect cRect);
	CPPView* GetContentView(void);
	
	void SetContentRect(CGRect cRect);
	
	CGRect GetWindowFrame(void);
	CGRect GetContentFrame(void);
	
	// objective-c call functions
	virtual void InitWithContentRect(CGRect cRect, unsigned int style);
	void CloseWindow(void);
	
	void SetCppNsWindowPointer(CPPWindow *wnd);
	void SetDelegate(id del);
	
	void SetMinSize(CGFloat w, CGFloat h);
	void SetAcceptsMouseMovedEvents(BOOL mm);
	void SetTitle(id name);
	
	void MakeFirstResponder(id rspnd);
	void MakeKeyAndOrderFront(void);
	
	void SetContentView(id view);
	CGRect GetContentRect(void);
	
	void AddViewToWindowContent(CPPView *view);
	void SetContentSize(CGSize size);
	
	void SetBackgroundColor(CPPColor color);
	void SetBackgroundColor(CGFloat r, CGFloat g, CGFloat b, CGFloat a);
	
	void SetFrameOrigin(CGPoint origin);
	void SetFrameTopLeftPoint(CGPoint topLeft);
	
	void UpdateWindowFrame(void);
};


#endif