/*
 *  CPPControl.cpp
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/24/12.
 *  Copyright 2012 Libisch Graphic Design. All rights reserved.
 *
 */


#include "CPPControl.h"


/*****************************************************************************/
// CPPControl C++ class functions

CPPControl::CPPControl()
{
	active = FALSE;
}

CPPControl::~CPPControl()
{
}

void CPPControl::Draw(void)
{
}

bool CPPControl::Message(int msg, void *data)
{
	switch(msg)
	{
		case cppControlActivate:
			SetIsActive(TRUE);
			break;
		case cppControlDeactivate:
			SetIsActive(FALSE);
			break;
	}
	
	return TRUE;
}

void CPPControl::SetIsActive(bool flag)
{
	active = flag;
}

bool CPPControl::IsActive(void)
{
	return active;
}

void CPPControl::AddControlLabel(CPPControlLabel *label)
{
	AddSubview(label);
}



/*****************************************************************************/
// CPPControlLabel C++ class functions

CPPControlLabel::CPPControlLabel()
{
	centered = FALSE;
	SetRespondsToEvents(FALSE); // call to CPPResponder function
}

CPPControlLabel::~CPPControlLabel()
{
	//printf("Label destroyed\n");
}

id CPPControlLabel::InitLabel(int font, CGFloat size, const char *str, int align)
{
	CGRect textRect = CGRectMake(0,0,0,0);
	textRect.size = GetStringDrawingSize(font,size,str,5.0);
	
	id tView = InitWithFrame(textRect);
	SetViewRect(textRect);
	
	SetDrawsBackground(FALSE);
	SetNormalColor();
	SetFont(font,size);
	SetString(str);
	SetAlignment(align);
	
	MakeStaticText();
	
	return tView;
}

void CPPControlLabel::SetNormalColor(void)
{
	SetTextColor(labelNormalColor);
}

void CPPControlLabel::SetHilightColor(void)
{
	SetTextColor(labelHiliteColor);
}

void CPPControlLabel::CenterLabel(void)
{
	CGRect frm = GetSuperviewFrame();
	CGPoint pos;
	pos.x = (frm.size.width - vwRect.size.width) * 0.5;
	pos.y = (frm.size.height - vwRect.size.height) * 0.5;
	//SetFrameOrigin(pos);	
	SetViewOrigin(pos);	
	
	if(!IsCentered()) SetIsCentered(TRUE);
}

void CPPControlLabel::SetIsCentered(bool flag)
{
	centered = flag;
}

bool CPPControlLabel::IsCentered(void)
{
	return centered;
}

