/*
 *  CPPMainWindow.cpp
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/1/12.
 *  Copyright 2012 Dan Libisch. All rights reserved.
 *
 */

#include "CPPApplication.h"
#include "CPPMainWindow.h"
#include "CPPMenu.h"


CPPMainWindow::CPPMainWindow()
{
	glView = NULL;
	mBar = NULL;
}

CPPMainWindow::~CPPMainWindow()
{
	DeleteOpenGLView();
}

CPPMenuBar*  CPPMainWindow::InitWindowMenuBar(CGRect wndRect, CGFloat ht)
{
	mBar = new CPPMenuBar(); if(!mBar) return FALSE;
	
	mBar->SetViewMargins(0,0,0,-1);
	//CGRect mRect = CGRectMake(0,wndRect.size.height-ht,wndRect.size.width,ht);
	CGRect mRect = CGRectMake(0,0,wndRect.size.width,ht);
	mBar->InitWithFrame(mRect);
	
	AddViewToWindowContent(mBar);
	
	return mBar;
}

CPPMenuBar* CPPMainWindow::GetMenuBar(void)
{
	return mBar;
}

bool CPPMainWindow::CreateOpenGL3DViewPort(CGRect cRect)
{
	glView = new CPPOpenGL3DViewPort(); if(!glView) return FALSE;
	glView->InitWithFrame(cRect,true);
	
	AddViewToWindowContent(glView);
	
	return TRUE;
}

CPPOpenGL3DViewPort* CPPMainWindow::GetOpenGLView(void)
{
	return glView;
}

void CPPMainWindow::DeleteOpenGLView(void)
{
	if(glView)
	{
		delete glView;
		glView = NULL;
	}
}

bool CPPMainWindow::WindowShouldClose(void)
{
	if(CPPApp->Message(cppMainWindowClosesApplication))
	{
		if(!CPPRunAlertPanel("CPPAppKit","Are you sure you want to quit","OK","Cancel"))
		{
			MakeKeyAndOrderFront();
			return FALSE;
		}
		else
		{
			SetWindowIsOpen(FALSE);
			return TRUE;
		}
	}
	else
	{
		//if(window shouldn't close) return FALSE; else
		return TRUE;
	}
}


// window events
void CPPMainWindow::KeyDown(CGEventRef cgEvent)
{
	//printf("KCPPMainWindow::KeyDown \n");
	CGEventFlags flags = CGEventGetFlags(cgEvent);
	if(ModifierKey(cppCommandKey,flags))
	{
		switch(GetEventKeyCode(cgEvent))
		{
			case CPP_KEY_W:
				CloseWindow();
				break;
		}
	}
}

void CPPMainWindow::KeyUp(CGEventRef cgEvent)
{
	//printf("CPPMainWindow::KeyUp \n");
}

void CPPMainWindow::FlagsChanged(CGEventRef cgEvent)
{
	//printf("CPPMainWindow::FlagsChanged \n");
}
