/*
 *  CPPPanel.mm
 *  CPPAppKitTest
 *
 *  Created by Dan Libisch on 3/17/12.
 *  Copyright 2012 Libisch Graphic Design. All rights reserved.
 *
 */


#include <AppKit/AppKit.h>

#include "CPPPanel.h"


/*****************************************************************************/
// Objective-C  Class CppNsPanel : NSPanel

@interface CppNsPanel : NSPanel
{ CPPPanel *cppPanel; }
- (void)setCppNsPanelPointer:(CPPPanel*)pnl;
- (CPPPanel*)getCppNsPanelPointer;
@end


@implementation CppNsPanel
- (void)setCppNsPanelPointer:(CPPPanel*)pnl
{ cppPanel = pnl; }

- (CPPPanel*)getCppNsPanelPointer
{ return cppPanel; }
@end




/*****************************************************************************/
// CPPPanel Objective-C call functions

void CPPPanel::InitWithContentRect(CGRect cRect, unsigned int style)
{
	NSRect panelRect = NSRectFromCGRect(cRect);
	nsObjPtr = [[[CppNsPanel alloc] initWithContentRect:panelRect styleMask:style backing:NSBackingStoreBuffered defer:NO] autorelease];
 	SetCppNsPanelPointer(this);
	CreateContentView(cRect);
	
	//NSRect screenR = [[nsObjPtr screen] visibleFrame];
	//panelRect.origin = NSMakePoint(screenR.origin.x, screenR.origin.y + screenR.size.height - panelRect.size.height);
	//[nsObjPtr setFrame:[nsObjPtr frameRectForContentRect:panelRect] display:YES animate:YES];
}

void CPPPanel::SetCppNsPanelPointer(CPPPanel *pnl)
{
	[nsObjPtr setCppNsPanelPointer:pnl];
}

void CPPPanel::ClosePanel(void)
{
	[nsObjPtr close];
	SetWindowIsOpen(FALSE);
}

BOOL CPPPanel::IsFloatingPanel(void)
{
	return [nsObjPtr isFloatingPanel];
}

void CPPPanel::SetFloatingPanel(BOOL flag)
{
	[nsObjPtr setFloatingPanel:flag];
}

BOOL CPPPanel::BecomesKeyOnlyIfNeeded(void)
{
	return [nsObjPtr becomesKeyOnlyIfNeeded];
}

void CPPPanel::SetBecomesKeyOnlyIfNeeded(BOOL flag)
{
	[nsObjPtr setBecomesKeyOnlyIfNeeded:flag];
}

BOOL CPPPanel::WorksWhenModal(void)
{
	return [nsObjPtr worksWhenModal];
}

void CPPPanel::SetWorksWhenModal(BOOL flag)
{
	[nsObjPtr setWorksWhenModal:flag];
}



/*****************************************************************************/
// CPPPanel C++ class functions

CPPPanel::CPPPanel()
{
}

CPPPanel::~CPPPanel()
{
}

void CPPPanel::Draw(void)
{
}

bool CPPPanel::Message(int msg, void *data)
{
	return TRUE;
}

void CPPPanel::OpenPanel(void)
{
	MakeKeyAndOrderFront();
}

